import React, { FC } from 'react';
import {
  Input as InputX,
  NativeBase,
  Item,
  Label,
  RnViewStyleProp,
} from 'native-base';
import { StyleSheet } from 'react-native';
const styles = StyleSheet.create({
  material: {
    // borderWidth: 1,
    borderColor: 'white',
    borderBottomWidth: 1,
    color: 'white',
    // borderRadius: 6,
    // backgroundColor: 'white',
  },
  textMaterial: {
    color: 'white',
    // position: 'absolute',
    // top: -16,
    fontFamily: 'roboto',
    fontWeight: 'normal',
    fontSize: 17,
  },
  default: {
    // borderWidth: 1,
    // borderColor: 'white',
    borderBottomWidth: 0,
    // color: 'white',
    borderRadius: 5,
    backgroundColor: 'white',
    height: 80,
    margin: 0,
    // padding: 24
  },
  textDefault: {
    color: 'white',
    // position: 'absolute',
    // top: -26,
    // marginTop: -50,
    marginBottom: 18,
    fontFamily: 'roboto',
    fontWeight: 'normal',
    fontSize: 17,
  },
  itemStyle: {
    height: 88,
    borderBottomWidth: 0,
  },
});
type Props = NativeBase.Input & {
  type?: 'material' | 'primary';
  inputStyle?: any;
  label?: string;
  style?: RnViewStyleProp;
  labelProps?: NativeBase.Label;
  inputProps?: NativeBase.Input;
  // children: ReactNode;
};
export const Input: FC<Props> = (props: Props) => {
  const { type, label, labelProps, style, inputStyle } = props;
  const propsX = { ...props };
  propsX.style = inputStyle;
  delete propsX.labelProps;
  delete propsX.type;
  delete propsX.label;
  delete propsX.inputStyle;

  const renderElement = (inputStyleX?: any, labelStyle?: any) => {
    return (
      <Item
        stackedLabel
        style={
          style !== undefined
            ? { ...(style as object), ...styles.itemStyle }
            : styles.itemStyle
        }
      >
        {label && (
          <Label
            {...labelProps}
            style={
              labelProps?.style
                ? { ...labelStyle, ...(labelProps.style as object) }
                : labelStyle
            }
          >
            {label}
          </Label>
        )}
        <InputX
          {...propsX}
          style={inputStyle ? { ...inputStyle, ...inputStyleX } : inputStyleX}
        />
      </Item>
    );
  };
  switch (type) {
    case 'material':
      return renderElement(styles.material, styles.textMaterial);
    // case 'custom':
    //   return (
    //     <ButtonX {...propsX}>
    //       {propsX.icon && <Icon {...iconProps} />}
    //       <Text uppercase={false} {...textProps}>{props.children}</Text>
    //     </ButtonX>
    //   );
    default:
      return renderElement(styles.default, styles.textDefault);
  }
};
